<template>
  <div class="loginContainer">
    <h1 class="formTitle">Login</h1>
    <label for="username" class="loginLabel">Username</label>
    <input v-model="username" id="username" class="loginInput" />
    <label for="password" class="loginLabel">Password</label>
    <input v-model="password" id="password" type="password" class="loginInput" />
    <button
      v-on:click="requestLogin"
      class="loginButton bg-transparent hover:bg-blue-500 text-blue-700 font-semibold hover:text-white py-2 px-4 border border-blue-500 hover:border-transparent rounded"
    >Login</button>
  </div>
</template>

<script lang="ts">
import gql from 'graphql-tag';
import { print } from 'graphql';
import { Component, Prop, Vue } from 'vue-property-decorator';
import axios from 'axios';

const mutation = gql`
  mutation login($username: String!, $password: String!) {
    login(data: { username: $username, password: $password }) {
      token
    }
  }
`;

@Component
export default class LoginForm extends Vue {
  public username: string;
  public password: string;

  constructor() {
    super();
    this.username = '';
    this.password = '';
  }

  public async requestLogin() {
    try {
      const response = await axios.post('http://localhost:1234/graphql', {
        query: print(mutation),
        variables: {
          username: this.username,
          password: this.password,
        },
      });
      if (!response.data.errors) {
        alert('Got token');
        const token = response.data.data.login.token;
        localStorage.setItem('blognizer-session-token', token);
      } else {
        alert('Error getting token');
      }
    } catch (error) {
        alert('Error in the request');
    }
  }
}
</script>

<style lang="postcss" scoped>
.loginContainer {
  @apply flex flex-col w-1/3 justify-between mx-auto;
}
.formTitle {
  @apply text-3xl border-b-2 mb-2;
  animation: widen 0.7s ease-in;
}
@keyframes widen {
  0% {
    transform: scale(0);
  }
  95% {
    transform: scale(1.5);
  }
  100% {
    transform: scale(1);
  }
}
.loginLabel {
  @apply text-xl;
  animation: widen 0.9s ease-in;
}
.loginInput {
  @apply mb-5 pt-2 pb-2 pl-5 pr-5 border-solid border border-gray-400 w-full outline-none text-center text-xl;
  animation: widen 1.1s ease-in;
}
.loginButton {
  animation: widen 1.3s ease-in;
}
</style>
